## aseba 1.6.0

=== CMakeLists.txt ===
# emacs: -*- CMake -*-
# kate: replace-tabs off; tab-width 4; indent-width 4; tab-indents true; indent-mode normal
# vim: ts=4:sw=4:noexpandtab

# project name
project(aseba)

# ensure a minimal version of CMake
cmake_minimum_required(VERSION 2.8.12)

# additional CMake modules
set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/CMakeModules)
include(CMakeModules/ParseVersion.cmake)

# check the compiler version as we need full C++11 support
if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
	# using Clang
	if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS "3.4")
		message(FATAL_ERROR, "Your clang compiler has version ${CMAKE_CXX_COMPILER_VERSION}, while version 3.4 or later is required")
	endif ()
elseif(CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
	# using AppleClang
	if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "5.1")
		message(FATAL_ERROR "Your XCode environment has version ${CMAKE_CXX_COMPILER_VERSION}, while version 5.1 or later is required")
	endif()
elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
	# using GCC
	if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS "5")
		message(FATAL_ERROR, "Your g++ compiler has version ${CMAKE_CXX_COMPILER_VERSION}, while version 5 or later is required")
	endif ()
elseif (CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
	# using MSVC
	if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "19.0.23506")
		message(FATAL_ERROR "Your Microsoft Visual C++ compiler has version ${CMAKE_CXX_COMPILER_VERSION}, while version MSVC 2015 Update 1+ is required")
	endif()
endif ()

# enable C++11 support
if (CMAKE_VERSION VERSION_LESS "3.1")
	if (MSVC)
		message(FATAL_ERROR, "CMake version 3.1 or later is required to compiler Aseba with Microsoft Visual C++")
	endif ()
	set (CMAKE_CXX_FLAGS "-std=c++14 ${CMAKE_CXX_FLAGS}")
else ()
	set (CMAKE_CXX_STANDARD 14)
endif ()

# reduce the amount of recursive include trash on Windows
if (WIN32)
	add_definitions(-DWIN32_LEAN_AND_MEAN)
endif()

# Remove -Wl,--no-undefined which CMake 3.0.2 (on OpenSUSE 13.2) adds to the
# linker options when building shared libs. That breaks building libs that use
# callbacks that will be provided by other libs when the executable is linked.
if (DEFINED CMAKE_SHARED_LINKER_FLAGS)
	STRING(REPLACE "-Wl,--no-undefined" "" CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS}")
endif (DEFINED CMAKE_SHARED_LINKER_FLAGS)

# testing and defines
enable_testing()
add_definitions(-Wall)
add_definitions(-DASEBA_ASSERT)

# Dashel
find_package(dashel REQUIRED)
include_directories(${dashel_INCLUDE_DIRS})

# Enki
find_package(enki)

# Qt
# FindQt4 has a bug and does not support OPTIONAL_COMPONENTS
# see https://cmake.org/pipermail/cmake/2016-March/063047.html
#find_package(Qt4 COMPONENTS QtCore QtGui QtNetwork QtXml QtHelp QtSvg QtWebKit OPTIONAL_COMPONENTS QtDBus)
# So we use a two-step mechanism, first try with DBus, and if not found, try without
find_package(Qt4 COMPONENTS QtCore QtGui QtNetwork QtXml QtHelp QtSvg QtWebKit QtDBus)
if (NOT QT_QTDBUS_FOUND)
	find_package(Qt4 COMPONENTS QtCore QtGui QtNetwork QtXml QtHelp QtSvg QtWebKit)
endif ()

# Qwt
find_path(QWT_INCLUDE_DIR qwt_plot.h PATHS /usr/include/ /usr/local/include PATH_SUFFIXES qwt5-qt4 qwt-qt4 qwt)
find_library(QWT_LIBRARIES NAMES qwt5-qt4 qwt-qt4 qwt PATHS /usr/lib /usr/local/lib)
if (QWT_LIBRARIES AND QWT_INCLUDE_DIR)
	message(STATUS "Qwt found")
else (QWT_LIBRARIES AND QWT_INCLUDE_DIR)
	message(STATUS "Qwt not found")
endif (QWT_LIBRARIES AND QWT_INCLUDE_DIR)

# Zeroconf
find_package(DNSSD)
if (DNSSD_FOUND)
	if(AVAHI_COMMON_LIBRARIES)
		add_definitions(-DDNSSD_AVAHI)
	endif(AVAHI_COMMON_LIBRARIES)
	include_directories(${DNSSD_INCLUDE_DIRS})
	find_package(Threads REQUIRED)
	add_definitions(-DZEROCONF_SUPPORT)
endif()

# Aseba itself
set(LIB_INSTALL_DIR lib CACHE FILEPATH "Where to install libraries")
set(LIB_VERSION_MAJOR 3) # Must be bumped for incompatible ABI changes
set(LIB_VERSION_MINOR 0)
set(LIB_VERSION_PATCH 0)
set(LIB_VERSION_STRING ${LIB_VERSION_MAJOR}.${LIB_VERSION_MINOR}.${LIB_VERSION_PATCH})

# Core libraries
add_subdirectory(common)
add_subdirectory(transport)

# define the core libraries variable, to be used by all Aseba programs
set(ASEBA_CORE_LIBRARIES asebadashelplugins asebacommon ${dashel_LIBRARIES})
if (DNSSD_FOUND)
	if (AVAHI_COMMON_LIBRARIES)
		set(ASEBA_ZEROCONF_ADDITIONAL_LIBRARIES ${AVAHI_CLIENT_LIBRARIES} ${AVAHI_COMMON_LIBRARIES} ${DNSSD_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
	else()
		set(ASEBA_ZEROCONF_ADDITIONAL_LIBRARIES ${DNSSD_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
		if (WIN32)
			set(ASEBA_ZEROCONF_ADDITIONAL_LIBRARIES ${ASEBA_ZEROCONF_ADDITIONAL_LIBRARIES} -lws2_32)
		endif()
	endif()
	set(ASEBA_ZEROCONF_LIBRARIES asebazeroconf ${ASEBA_ZEROCONF_ADDITIONAL_LIBRARIES})
	if (QT4_FOUND)
		set(ASEBA_ZEROCONFQT_LIBRARIES asebazeroconfqt asebazeroconf ${ASEBA_ZEROCONF_ADDITIONAL_LIBRARIES})
	endif()
endif()

# Target and client specific libraries
add_subdirectory(vm)
add_subdirectory(compiler)

# User programs
add_subdirectory(clients)
add_subdirectory(switches)
add_subdirectory(targets)

# Examples for developers
add_subdirectory(examples)

# Unit tests
add_subdirectory(tests)

# User entries
if (UNIX)
	add_subdirectory(menu)
endif()

=== clients/CMakeLists.txt ===
# text-based
add_subdirectory(cmd)
add_subdirectory(dump)
add_subdirectory(replay)
add_subdirectory(exec)
add_subdirectory(joy)

# text-based using QtCore
add_subdirectory(massloader)

# gui
add_subdirectory(eventlogger)
add_subdirectory(studio)
add_subdirectory(thymioupgrader)
add_subdirectory(thymiownetconfig)

=== common/CMakeLists.txt ===
set (ASEBACOMMON_SRC
	utils/FormatableString.cpp
	utils/utils.cpp
	utils/HexFile.cpp
	utils/BootloaderInterface.cpp
	msg/msg.cpp
	msg/NodesManager.cpp
	msg/TargetDescription.cpp
)

add_library(asebacommon ${ASEBACOMMON_SRC})
set_target_properties(asebacommon PROPERTIES VERSION ${LIB_VERSION_STRING})

install(TARGETS asebacommon 
	LIBRARY DESTINATION ${LIB_INSTALL_DIR} 
	ARCHIVE DESTINATION ${LIB_INSTALL_DIR} 
)

set (ASEBACORE_HDR_UTILS 
	utils/utils.h
	utils/FormatableString.h
)
set (ASEBACORE_HDR_MSG
	msg/msg.h
	msg/NodesManager.h
	msg/TargetDescription.h
)
set (ASEBACORE_HDR_COMMON
	consts.h
	types.h
	productids.h
)
install(FILES ${ASEBACORE_HDR_UTILS}
	DESTINATION include/aseba/common/utils
)
install(FILES ${ASEBACORE_HDR_MSG}
	DESTINATION include/aseba/common/msg
)
install(FILES ${ASEBACORE_HDR_COMMON}
	DESTINATION include/aseba/common
)

add_subdirectory(about)
add_subdirectory(zeroconf)

=== targets/CMakeLists.txt ===
add_subdirectory(dummy)
add_subdirectory(enki-marxbot)
add_subdirectory(challenge)
add_subdirectory(playground)

=== tests/CMakeLists.txt ===
find_program(valgrind_FOUND valgrind)
if (valgrind_FOUND)
	message(STATUS "valgrind executable found: " ${valgrind_FOUND})
else ()
	message(WARNING "valgrind executable not found! Disabling memory leaks and trashs tests")
endif ()

add_subdirectory(common)
add_subdirectory(msg)
add_subdirectory(compiler)
add_subdirectory(vm)
add_subdirectory(simulator)
#add_subdirectory(e2e-http)


# test asebahttp
# FIXME: port to asebahttp2
#find_package(LibXml2)
#if (LIBXML2_FOUND)
#	include_directories(${LIBXML2_INCLUDE_DIR})
#	include_directories(externals/Catch/include ${COMMON_INCLUDES})
#	add_executable(test-asebahttp test-http.cpp)
#	if (CMAKE_VERSION VERSION_EQUAL "2.8.12" OR CMAKE_VERSION VERSION_GREATER "2.8.12")
#		# Support compilers like GCC 5 that don't have C++11 support enabled by default.
#		target_compile_definitions(test-asebahttp PRIVATE -DCATCH_CONFIG_NO_CPP11)
#	endif ()
#	target_link_libraries(test-asebahttp asebahttphub asebacompiler ${LIBXML2_LIBRARIES} ${ASEBA_CORE_LIBRARIES})
#	configure_file(testdata-HttpRequest.txt ${CMAKE_CURRENT_BINARY_DIR}/testdata-HttpRequest.txt COPYONLY)
#	configure_file(http-valgrind-macosx.supp ${CMAKE_CURRENT_BINARY_DIR}/http-valgrind-macosx.supp COPYONLY)
#	# test HTTP requests and JSON parsing
#	configure_file(run-test-asebahttp.sh ${CMAKE_CURRENT_BINARY_DIR}/run-test-asebahttp.sh COPYONLY)
#	add_test(NAME test-asebahttp COMMAND bash run-test-asebahttp.sh)
#else (LIBXML2_FOUND)
#	message(WARNING "libXML2 not found! Disabling HTTP switch tests")
#endif (LIBXML2_FOUND)

=== vm/CMakeLists.txt ===
if (APPLE)
	add_definitions(-DDISABLE_WEAK_CALLBACKS)
endif (APPLE)
set (ASEBAVM_SRC
	vm.c
	natives.c
)
add_library(asebavm ${ASEBAVM_SRC})
set_target_properties(asebavm PROPERTIES VERSION ${LIB_VERSION_STRING} 
                                        SOVERSION ${LIB_VERSION_MAJOR})

install(TARGETS asebavm 
                LIBRARY DESTINATION ${LIB_INSTALL_DIR} 
                ARCHIVE DESTINATION ${LIB_INSTALL_DIR} 
)

set (ASEBAVM_HDR_COMPILER
	vm.h
	natives.h
)
install(FILES ${ASEBAVM_HDR_COMPILER}
	DESTINATION include/aseba/vm
)

=== clients/cmd/CMakeLists.txt ===
add_executable(asebacmd
	cmd.cpp
)
target_link_libraries(asebacmd ${ASEBA_CORE_LIBRARIES})
install(TARGETS asebacmd RUNTIME
	DESTINATION bin
)

=== clients/dump/CMakeLists.txt ===
add_executable(asebadump
	dump.cpp
)
target_link_libraries(asebadump ${ASEBA_CORE_LIBRARIES})
install(TARGETS asebadump RUNTIME
	DESTINATION bin
)

=== clients/eventlogger/CMakeLists.txt ===
if (QT4_FOUND)
	include(${QT_USE_FILE})
	
	if (QWT_INCLUDE_DIR AND QWT_LIBRARIES)
	
		set(eventlogger_SRCS eventlogger.cpp)
		
		include_directories (${QWT_INCLUDE_DIR} ${QT_INCLUDE_DIR} ${CMAKE_BINARY_DIR}/eventlogger)
		
		#add_executable(asebastudio WIN32 ${eventlogger_SRCS} ${resfiles})
		add_executable(asebaeventlogger WIN32 ${eventlogger_SRCS})
		
		# Only include the qtmain lib if we are on the windows platform
		if (WIN32)
			target_link_libraries(asebaeventlogger ${QWT_LIBRARIES} ${QT_LIBRARIES} ${QT_QTMAIN_LIBRARY}  ${ASEBA_CORE_LIBRARIES})
		else (WIN32)
			target_link_libraries(asebaeventlogger ${QWT_LIBRARIES} ${QT_LIBRARIES}  ${ASEBA_CORE_LIBRARIES})
		endif (WIN32)
	
	else (QWT_INCLUDE_DIR AND QWT_LIBRARIES)
	
		message(WARNING "Cannot find Qwt")
		
	endif (QWT_INCLUDE_DIR AND QWT_LIBRARIES)
	
endif (QT4_FOUND)

=== clients/massloader/CMakeLists.txt ===
if (QT4_FOUND)
	set(QT_USE_QTXML ON)
	set(QT_DONT_USE_QTGUI ON)
	include(${QT_USE_FILE})

# 	set(thymioupgrader_SRCS
# 		ThymioUpgrader.cpp)
# 	qt4_wrap_cpp(thymioupgrader_MOCS
# 		ThymioUpgrader.h
# 	)
	
	#include_directories (${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_BINARY_DIR})
	
	add_executable(asebamassloader massloader.cpp)

	target_link_libraries(asebamassloader asebacompiler ${QT_LIBRARIES} ${ASEBA_CORE_LIBRARIES})

	install(TARGETS asebamassloader RUNTIME DESTINATION bin)

endif (QT4_FOUND)

=== clients/replay/CMakeLists.txt ===
add_executable(asebarec
	rec.cpp
)
target_link_libraries(asebarec ${ASEBA_CORE_LIBRARIES})
install(TARGETS asebarec RUNTIME
	DESTINATION bin
)

add_executable(asebaplay
	play.cpp
)
target_link_libraries(asebaplay ${ASEBA_CORE_LIBRARIES})
install(TARGETS asebaplay RUNTIME
	DESTINATION bin
)

=== clients/studio/CMakeLists.txt ===
# kate: replace-tabs off; tab-width 4; indent-width 4; tab-indents true; indent-mode normal
# vim: ts=4:sw=4:noexpandtab
set(DOC_NAME aseba-doc)

# file(TO_NATIVE_PATH ...) is broken with MSYS generator 
# (http://www.kwwidgets.org/Bug/bug_view_advanced_page.php?bug_id=5939)
# This is a replacement...
# From : http://www.cmake.org/pipermail/cmake/2006-July/010180.html
MACRO(MAKE_WINDOWS_PATH pathname)
	# An extra \\ escape is necessary to get a \ through CMake's processing.
	STRING(REPLACE "/" "\\" ${pathname} "${${pathname}}")
	# Enclose with UNESCAPED quotes.  This means we need to escape our
	# quotes once here, i.e. with \"
	SET(${pathname} \"${${pathname}}\")
ENDMACRO(MAKE_WINDOWS_PATH)

# link for Studio
set(ADDITIONAL_LIBRARIES "")

# Google protobuf
find_package(Protobuf)
if (PROTOBUF_FOUND AND PROTOBUF_PROTOC_EXECUTABLE)
	add_definitions(-DPROTOBUF_FOUND)
	include_directories(${PROTOBUF_INCLUDE_DIR})
	set(ADDITIONAL_LIBRARIES ${ADDITIONAL_LIBRARIES} ${PROTOBUF_LIBRARY})
	message(STATUS "Google Protobuf library and compiler found, enabling usage logging")
else (PROTOBUF_FOUND AND PROTOBUF_PROTOC_EXECUTABLE)
	message(STATUS "Google Protobuf library and compiler *not* found, usage logging disabled.") 
endif (PROTOBUF_FOUND AND PROTOBUF_PROTOC_EXECUTABLE)

# Zeroconf
if (DNSSD_FOUND)
	set(ADDITIONAL_LIBRARIES ${ADDITIONAL_LIBRARIES} ${ASEBA_ZEROCONFQT_LIBRARIES})
endif()

if (QT4_FOUND AND QT_QTWEBKIT_FOUND)
	set(QT_USE_QTXML ON)
	set(QT_USE_QTNETWORK ON)
	set(QT_USE_QTMAIN ON)
	set(QT_USE_QTHELP ON)
	set(QT_USE_QTCONCURRENT ON)
	set(QT_USE_QTSVG ON)
	set(QT_USE_QTWEBKIT ON)
	include(${QT_USE_FILE})

	# add a console for debug messages under Windows
	if (WIN32)
		set(CMAKE_EXE_LINKER_FLAGS_DEBUG "-Wl,-subsystem,console ${CMAKE_EXE_LINKER_FLAGS}")
	endif (WIN32)
	
	if(UNIX AND NOT APPLE)
		set(ASEBA_ENABLE_BLOCKLY_PLUGIN TRUE)
		add_definitions(-DASEBA_ENABLE_BLOCKLY_PLUGIN)
	endif(UNIX AND NOT APPLE)
	
	if (QWT_LIBRARIES AND QWT_INCLUDE_DIR)
		include_directories (${QWT_INCLUDE_DIR})
		set(ADDITIONAL_LIBRARIES ${ADDITIONAL_LIBRARIES} ${QWT_LIBRARIES})
		add_definitions(-DHAVE_QWT)
	endif (QWT_LIBRARIES AND QWT_INCLUDE_DIR)

	# generates the documentation
	if (QT_QTHELP_FOUND AND QT_QCOLLECTIONGENERATOR_EXECUTABLE)
		message(STATUS "qcollectiongenerator executable found")
		# Use PATH instead of DIRECTORY on next line to support CMake < 2.8.11
		get_filename_component(QT_QCOLLECTIONGENERATOR_DIRECTORY ${QT_QCOLLECTIONGENERATOR_EXECUTABLE} PATH)
		get_filename_component(QT_QCOLLECTIONGENERATOR_EXT ${QT_QCOLLECTIONGENERATOR_EXECUTABLE} EXT)
		set(QT_QHELPGENERATOR_EXECUTABLE "${QT_QCOLLECTIONGENERATOR_DIRECTORY}/qhelpgenerator${QT_QCOLLECTIONGENERATOR_EXT}")
		add_custom_command(
			OUTPUT ${DOC_NAME}.qch
			COMMAND ${QT_QHELPGENERATOR_EXECUTABLE} ARGS ${CMAKE_CURRENT_SOURCE_DIR}/${DOC_NAME}.qhp -o ${CMAKE_CURRENT_BINARY_DIR}/${DOC_NAME}.qch
			DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${DOC_NAME}.qhp)
		add_custom_command(
			OUTPUT ${DOC_NAME}.qhc
			COMMAND ${QT_QCOLLECTIONGENERATOR_EXECUTABLE} ARGS ${DOC_NAME}.qhcp -o ${DOC_NAME}.qhc
			DEPENDS ${DOC_NAME}.qhcp ${DOC_NAME}.qch)
	else (QT_QTHELP_FOUND AND QT_QCOLLECTIONGENERATOR_EXECUTABLE)
		message(WARNING "Qt help support missing, studio online help disabled (hint: on Ubuntu, install package qt4-dev-tools)")
	endif (QT_QTHELP_FOUND AND QT_QCOLLECTIONGENERATOR_EXECUTABLE)
	
	# code common to the use of Aseba under Qt
	set(qt_common_SRCS
		Target.cpp
		DashelTarget.cpp
		TargetModels.cpp
		CustomWidgets.cpp
		AeslEditor.cpp
		Plugin.cpp
		translations/CompilerTranslator.cpp
	)
	qt4_wrap_cpp(qt_common_MOCS
		Target.h
		DashelTarget.h
		TargetModels.h
		AeslEditor.h
		translations/CompilerTranslator.h
	)
	add_library(asebaqtcommon STATIC ${qt_common_SRCS} ${qt_common_MOCS})
	
	# plugins
	add_subdirectory(plugins)
	
	# resources
	qt4_add_resources(resfiles asebastudio.qrc)
	
	include_directories (${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_BINARY_DIR})

	if (QT_QTHELP_FOUND)
		# studio for desktop use
		set(studio_SRCS
			StudioAeslEditor.cpp
			PluginRegistry.cpp
			MainWindow.cpp
			NamedValuesVectorModel.cpp
			ClickableLabel.cpp
			CustomDelegate.cpp
			main.cpp
			FindDialog.cpp
			EventViewer.cpp
			HelpViewer.cpp
			ConfigDialog.cpp
			ModelAggregator.cpp
		)
		qt4_wrap_cpp(studio_MOCS
			StudioAeslEditor.h
			MainWindow.h
			NamedValuesVectorModel.h
			ClickableLabel.h
			CustomDelegate.h
			FindDialog.h
			EventViewer.h
			HelpViewer.h
			ConfigDialog.h
			ModelAggregator.h
		)

		if (QT_QCOLLECTIONGENERATOR_EXECUTABLE)
			file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/asebastudiohelp.qrc ${CMAKE_CURRENT_SOURCE_DIR}/aseba-doc.qhcp DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
			qt4_add_resources(resfiles ${CMAKE_CURRENT_BINARY_DIR}/asebastudiohelp.qrc)
		endif (QT_QCOLLECTIONGENERATOR_EXECUTABLE)

		add_executable(asebastudio WIN32 ${studio_SRCS} ${studio_MOCS} ${resfiles} ${CMAKE_BINARY_DIR}/version.h)
		if (HAS_DYN_VERSION)
			add_dependencies(asebastudio versionheader)
		endif (HAS_DYN_VERSION)

		target_link_libraries(asebastudio asebaqtplugins asebaqtcommon asebaqtabout asebacompiler ${ASEBA_CORE_LIBRARIES} ${ADDITIONAL_LIBRARIES} ${QT_LIBRARIES})
		
		install(TARGETS asebastudio RUNTIME DESTINATION bin LIBRARY DESTINATION bin)
	endif (QT_QTHELP_FOUND)
	
	# Thymio VPL standalone
	include_directories(${CMAKE_CURRENT_BINARY_DIR}/plugins/ThymioVPL)
	set(thymiovpl_SRCS
		ThymioVPLStandalone.cpp
		thymiovpl.cpp
	)
	qt4_wrap_cpp(thymiovpl_MOCS
		ThymioVPLStandalone.h
	)

	if (ANDROID)
		add_library(thymiovpl SHARED ${thymiovpl_SRCS} ${thymiovpl_MOCS} ${resfiles} ${CMAKE_BINARY_DIR}/version.h)
	else (ANDROID)
		add_executable(thymiovpl WIN32 ${thymiovpl_SRCS} ${thymiovpl_MOCS} ${resfiles} ${CMAKE_BINARY_DIR}/version.h)
	endif (ANDROID)
	if (HAS_DYN_VERSION)
		add_dependencies(thymiovpl versionheader)
	endif (HAS_DYN_VERSION)
	
	target_link_libraries(thymiovpl asebaqtplugins asebaqtcommon asebaqtabout asebacompiler ${ASEBA_CORE_LIBRARIES} ${ADDITIONAL_LIBRARIES} ${QT_LIBRARIES})
	
	# Render blocks helper
	set(rendervplblocks_SRCS
		rendervplblocks.cpp
	)
	add_executable(rendervplblocks WIN32 ${rendervplblocks_SRCS} ${resfiles} ${CMAKE_BINARY_DIR}/version.h)
	# Note: it is ugly to link so much libraries that are not used, but it allows to avoid splitting VPL into several libraries
	target_link_libraries(rendervplblocks asebaqtplugins asebaqtcommon asebaqtabout ${ASEBA_CORE_LIBRARIES} ${ADDITIONAL_LIBRARIES} ${QT_LIBRARIES})

	install(TARGETS thymiovpl RUNTIME DESTINATION bin LIBRARY DESTINATION bin)
endif (QT4_FOUND AND QT_QTWEBKIT_FOUND)

=== debian/changelog ===
aseba (1.6.0-3.1~build1) bionic; urgency=medium

  * No change reupload now that the enki-aseba issue is fixed.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 10 Apr 2018 20:08:17 +0200

aseba (1.6.0-3) unstable; urgency=medium

  * debian/control: new build dependencies are qtbase5-dev, qt5-qmake,
    libqt5opengl5-dev, libqt5webkit5-dev, qtbase5-dev, qtbase5-dev-tools,
    qttools5-dev, libqwt-qt5-dev, libqt5svg5-dev
  * patched CMakeLists.txt, .cpp and .h files to use Qt5. Closes: #891021
  * skipped the auto_test taget in debian/rules

 -- Georges Khaznadar <georgesk@debian.org>  Sat, 24 Feb 2018 14:45:29 +0100

aseba (1.6.0-2) unstable; urgency=medium

  * applied Adrian Bunk's patch. Closes: #890031

 -- Georges Khaznadar <georgesk@debian.org>  Sun, 11 Feb 2018 13:23:09 +0100

aseba (1.6.0-1) unstable; urgency=medium

  * Initial release (Closes: #888756)
  * Added build-dependencies not listed by the upstream packaging system:
    valgrind, libavahi-compat-libdnssd1, libprotobuf-dev, zzuf
  * Modified the cmake configuration to prevent building the
    plugin for blockly
  * added VCS information about collaborative GIT maintenance.

 -- Georges Khaznadar <georgesk@debian.org>  Sat, 03 Feb 2018 11:24:46 +0100

=== debian/control ===
Source: aseba
Section: devel
Priority: optional
Maintainer: Georges Khaznadar <georgesk@debian.org>
Build-Depends: debhelper (>= 10),
 cmake, python,
 qtbase5-dev, qt5-qmake, libqt5opengl5-dev, libqt5webkit5-dev,
 qtbase5-dev, qtbase5-dev-tools, qttools5-dev,
 libqt5svg5-dev, libqwt-qt5-dev, libqt5svg5-dev, qtchooser, qt5-default,
 libudev-dev, libxml2-dev, libsdl2-dev,
 libdashel-dev, libenki-dev,
 libavahi-compat-libdnssd-dev,
 valgrind, libprotobuf-dev, zzuf
Standards-Version: 4.1.3
Vcs-Browser: https://salsa.debian.org/science-team/aseba.git
Vcs-Git: https://salsa.debian.org/science-team/aseba.git
Homepage: https://www.thymio.org/

Package: aseba
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: aseba-plugin-blockly
Description: Event-based framework for distributed mobile robots control
 Aseba's core is a lightweight virtual machine, small enough to run on
 any 16 bits microcontroller.  In Aseba, all virtual machines are
 linked in a network and all their programs are developed and debugged
 from a single application, Aseba Studio.
 .
 Aseba allows one to program Thymio, a small robot to discover the
 universe of robotics and learn a robot's language.

=== debian/rules ===
#!/usr/bin/make -f

## enable parallel build only at home, where hostname is "georges"

ifeq ($(shell hostname), georges)
  PARALLEL =
else
  PARALLEL = --no-parallel
endif

export QT_SELECT=qt5

%:
	dh $@  $(PARALLEL)


override_dh_auto_test:
	:
	# skip the tests when building a package

## aseba 1.6.0.1

=== CMakeLists.txt ===
set (ASEBACOMPILER_SRC
	compiler.cpp
	errors.cpp
	identifier-lookup.cpp
	lexer.cpp
	parser.cpp
	analysis.cpp
	tree-build.cpp
	tree-expand.cpp
	tree-dump.cpp
	tree-typecheck.cpp
	tree-optimize.cpp
	tree-emit.cpp
)
add_library(asebacompiler ${ASEBACOMPILER_SRC})
set_target_properties(asebacompiler PROPERTIES VERSION ${LIB_VERSION_STRING} 
                                        SOVERSION ${LIB_VERSION_MAJOR})

install(TARGETS asebacompiler
                LIBRARY DESTINATION ${LIB_INSTALL_DIR} 
                ARCHIVE DESTINATION ${LIB_INSTALL_DIR} 
)

set (ASEBACORE_HDR_COMPILER
	compiler.h
	errors_code.h
)
install(FILES ${ASEBACORE_HDR_COMPILER}
	DESTINATION include/aseba/compiler
)

=== dashel_plugins/CMakeLists.txt ===
# Select plugins following system
if (ANDROID)
	set (ASEBADASHEL_PLUGINS_SRC android.cpp)
	message(STATUS "Enabling Dashel android plugin")
else (ANDROID)
	if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
		set (ASEBADASHEL_PLUGINS_SRC socketcan.cpp)
		message(STATUS "Enabling Dashel socketcan plugin")
	else (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
		set (ASEBADASHEL_PLUGINS_SRC none.cpp)
		message(STATUS "System is neither Linux nor Android, no Dashel plugins")
	endif (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
endif (ANDROID)

add_library(asebadashelplugins ${ASEBADASHEL_PLUGINS_SRC})
set_target_properties(asebadashelplugins PROPERTIES VERSION ${LIB_VERSION_STRING} 
                                        SOVERSION ${LIB_VERSION_MAJOR})
install(TARGETS asebadashelplugins 
		LIBRARY DESTINATION ${LIB_INSTALL_DIR} 
		ARCHIVE DESTINATION ${LIB_INSTALL_DIR} 
)
install(FILES dashel-plugins.h
	DESTINATION include/aseba/transport/dashel_plugins
)

=== exec/CMakeLists.txt ===
add_executable(asebaexec
	exec.cpp
)
target_link_libraries(asebaexec ${ASEBA_CORE_LIBRARIES})
install(TARGETS asebaexec RUNTIME
	DESTINATION bin
)

=== joy/CMakeLists.txt ===
find_package(SDL2)
if (SDL2_FOUND)
	message(STATUS "SDL2 found, enabling joystick/joypad support")
	include_directories(${SDL2_INCLUDE_DIR})

	add_executable(asebajoy
		asebajoy.cpp
	)
	target_link_libraries(asebajoy ${ASEBA_CORE_LIBRARIES} ${SDL2_LIBRARY})
	install(TARGETS asebajoy RUNTIME
		DESTINATION bin
	)
else (SDL2_FOUND)
	message(STATUS "SDL2 *not* found, disabling joystick/joypad support")
endif (SDL2_FOUND)

=== switch/CMakeLists.txt ===
add_executable(asebaswitch
	switch.cpp
)

target_link_libraries(asebaswitch ${ASEBA_ZEROCONF_LIBRARIES} ${ASEBA_CORE_LIBRARIES})

install(TARGETS asebaswitch RUNTIME
	DESTINATION bin
)

=== clients/cpp-shell/CMakeLists.txt ===
# libxml2
find_package(LibXml2)
if (LIBXML2_FOUND)
	include_directories(${LIBXML2_INCLUDE_DIR})

	add_executable(asebashell
		shell.cpp
	)
	target_link_libraries(asebashell asebacompiler ${LIBXML2_LIBRARIES} ${ASEBA_CORE_LIBRARIES})
endif (LIBXML2_FOUND)

=== studio/plugins/CMakeLists.txt ===
set(qt_plugins_SRCS
	VariablesViewPlugin.cpp
	StopThymioPlugin.cpp
	ThymioVPL/ThymioVisualProgramming.cpp
	ThymioVPL/ResizingView.cpp
	ThymioVPL/Buttons.cpp
	ThymioVPL/Block.cpp
	ThymioVPL/EventBlocks.cpp
	ThymioVPL/StateBlocks.cpp
	ThymioVPL/ActionBlocks.cpp
	ThymioVPL/EventActionsSet.cpp
	ThymioVPL/Scene.cpp
	ThymioVPL/Compiler.cpp
	ThymioVPL/CompilerVisitors.cpp
	ThymioVPL/Style.cpp
	ThymioVPL/Utils.cpp
	ThymioVPL/LogSignalMapper.cpp
)

qt4_wrap_cpp(qt_plugins_MOCS
	VariablesViewPlugin.h
	StopThymioPlugin.h
	ThymioVPL/ThymioVisualProgramming.h
	ThymioVPL/ResizingView.h
	ThymioVPL/Buttons.h
	ThymioVPL/Block.h
	ThymioVPL/EventBlocks.h
	ThymioVPL/ActionBlocks.h
	ThymioVPL/EventActionsSet.h
	ThymioVPL/Scene.h
	ThymioVPL/UsageLogger.h
	ThymioVPL/LogSignalMapper.h
)

if(ASEBA_ENABLE_BLOCKLY_PLUGIN)
	list(APPEND qt_plugins_SRCS ThymioBlockly/ThymioBlockly.cpp)
	qt4_wrap_cpp(qt_plugins_MOCS ThymioBlockly/AsebaJavascriptInterface.h ThymioBlockly/ThymioBlockly.h)
endif(ASEBA_ENABLE_BLOCKLY_PLUGIN)

if (PROTOBUF_FOUND AND PROTOBUF_PROTOC_EXECUTABLE)
	execute_process(COMMAND ${PROTOBUF_PROTOC_EXECUTABLE} --cpp_out=${CMAKE_CURRENT_BINARY_DIR}/ThymioVPL -I${CMAKE_CURRENT_SOURCE_DIR}/ThymioVPL ${CMAKE_CURRENT_SOURCE_DIR}/ThymioVPL/UsageProfile.proto)
	include_directories(${CMAKE_CURRENT_BINARY_DIR}/ThymioVPL)
	set(qt_plugins_SRCS ${qt_plugins_SRCS} ThymioVPL/UsageProfile.pb.cc ThymioVPL/UsageLogger.cpp)
endif (PROTOBUF_FOUND AND PROTOBUF_PROTOC_EXECUTABLE)


add_library(asebaqtplugins STATIC ${qt_plugins_SRCS} ${qt_plugins_MOCS})

=== switches/botspeak/CMakeLists.txt ===
add_executable(asebabotspeak
	botspeak.cpp
)

target_link_libraries(asebabotspeak asebacompiler ${ASEBA_CORE_LIBRARIES})

=== debian/changelog ===
aseba (1.6.0.1-5) unstable; urgency=medium

  * update changelog

 -- deepin <lichenggang@uniontech.com>  Tue, 22 Jun 2021 16:07:58 +0800

aseba (1.6.0-5) unstable; urgency=medium

  * enabled the build under clients/studio. Closes: #907531
  * checked that the build is OK for powerpc/ppc64. Closes: #890570

 -- Georges Khaznadar <georgesk@debian.org>  Sun, 13 Jan 2019 20:14:26 +0100

aseba (1.6.0-4) unstable; urgency=medium

  * upgraded Standards-Version: 4.1.4
  * specified a list of architectures for the dependency on valgrind.
    Closes: #896147; Closes: #890569.

 -- Georges Khaznadar <georgesk@debian.org>  Sun, 20 May 2018 17:07:09 +0200

## aseba 1.6.99%2Bdfsg

=== aseba/clients/CMakeLists.txt ===
# text-based
add_subdirectory(cmd)
add_subdirectory(dump)
add_subdirectory(replay)
add_subdirectory(exec)

# text-based using QtCore
add_subdirectory(massloader)

# gui

if (Qt5Widgets_FOUND)
	add_subdirectory(eventlogger)
	if (Qt5Concurrent_FOUND AND Qt5Network_FOUND AND Qt5Xml_FOUND)
		add_subdirectory(thymioupgrader)
		set(HAS_THYMIO_UPGRADER ON)
	endif()


	add_subdirectory(thymiownetconfig)
	set(HAS_GRAPHICAL_CLIENTS ON)

	if(Qt5OpenGL_FOUND AND Qt5Xml_FOUND)
		set(HAS_STUDIO ON)
		add_subdirectory(studio)
	endif()


endif()

find_package(SDL2)
if (SDL2_FOUND)
add_subdirectory(joy)
endif()


add_feature_info(THYMIO_CONFIG HAS_GRAPHICAL_CLIENTS "studio thymio config/upgrader, event logger (depends on QtWidgets )")
add_feature_info(THYMIO_CONFIG HAS_THYMIO_UPGRADER   "upgrader (depends on QtConcurrent )")
add_feature_info(STUDIO HAS_STUDIO "Studio")
add_feature_info(JOY SDL2_FOUND "Aseba Joy ( depends on SDL )")

=== aseba/clients/cmd/CMakeLists.txt ===
add_executable(asebacmd
	cmd.cpp
)
target_link_libraries(asebacmd asebacommon asebadashelplugins)
install(TARGETS asebacmd RUNTIME
	DESTINATION bin
)
codesign(asebacmd)

=== aseba/clients/thymioupgrader/CMakeLists.txt ===
if (Qt5Widgets_FOUND AND Qt5Concurrent_FOUND AND Qt5Network_FOUND AND Qt5Xml_FOUND)

	# add a console for debug messages under Windows
	if (WIN32)
		set(CMAKE_EXE_LINKER_FLAGS_DEBUG "-Wl,-subsystem,console ${CMAKE_EXE_LINKER_FLAGS}")
	endif (WIN32)

	set(thymioupgrader_SRCS
		ThymioUpgrader.cpp)
	qt5_wrap_cpp(thymioupgrader_MOCS
		ThymioUpgrader.h
	)

	file(GLOB TRANSLATIONS_SOURCES "thymioupgrader*.ts")
	set_source_files_properties(${TRANSLATIONS_SOURCES} PROPERTIES OUTPUT_LOCATION "${CMAKE_CURRENT_SOURCE_DIR}")
	qt5_add_translation(TRANSLATIONS ${TRANSLATIONS_SOURCES} )
	qt5_add_resources(resfiles thymioupgrader.qrc)

	include_directories (${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_BINARY_DIR})

	add_executable(thymioupgrader WIN32 ${thymioupgrader_SRCS} ${thymioupgrader_MOCS} ${resfiles})
	if (HAS_DYN_VERSION)
		add_dependencies(thymioupgrader versionheader)
	endif (HAS_DYN_VERSION)

	target_link_libraries(thymioupgrader Qt5::Concurrent Qt5::Network Qt5::Xml Qt5::Widgets asebacommon asebadashelplugins)

	install_qt_app(thymioupgrader)
	codesign(thymioupgrader)

endif ()

=== aseba/transport/dashel_plugins/CMakeLists.txt ===
# Select plugins following system
if (ANDROID)
	set (ASEBADASHEL_PLUGINS_SRC android.cpp)
	message(STATUS "Enabling Dashel android plugin")
else (ANDROID)
	if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
		set (ASEBADASHEL_PLUGINS_SRC socketcan.cpp)
		message(STATUS "Enabling Dashel socketcan plugin")
	else (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
		set (ASEBADASHEL_PLUGINS_SRC none.cpp)
		message(STATUS "System is neither Linux nor Android, no Dashel plugins")
	endif (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
endif (ANDROID)

add_library(asebadashelplugins ${ASEBADASHEL_PLUGINS_SRC})
set_target_properties(asebadashelplugins PROPERTIES VERSION ${LIB_VERSION_STRING} 
                                        SOVERSION ${LIB_VERSION_MAJOR})

target_link_libraries(asebadashelplugins PUBLIC dashel aseba_conf)

install(TARGETS asebadashelplugins 
		LIBRARY DESTINATION ${LIB_INSTALL_DIR} 
		ARCHIVE DESTINATION ${LIB_INSTALL_DIR} 
)
install(FILES dashel-plugins.h
	DESTINATION include/aseba/transport/dashel_plugins
)

## aseba 1.6.99+dfsg

=== CMakeLists.txt ===
# emacs: -*- CMake -*-
# kate: replace-tabs off; tab-width 4; indent-width 4; tab-indents true; indent-mode normal
# vim: ts=4:sw=4:noexpandtab

# project name
project(aseba)

add_compile_options("$<$<C_COMPILER_ID:MSVC>:/utf-8>")
add_compile_options("$<$<CXX_COMPILER_ID:MSVC>:/utf-8>")

# ensure a minimal version of CMake
cmake_minimum_required(VERSION 3.5)
include(FeatureSummary)

# additional CMake modules
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/CMakeModules)
include(CMakeModules/ParseVersion.cmake)
include(CMakeModules/cpp_features.cmake)
include(CMakeModules/workarounds.cmake)
include(CMakeModules/aseba_conf.cmake)
include(CMakeModules/dashel.cmake)
include(CMakeModules/enki.cmake)
include(CMakeModules/deployqt.cmake)
include(CMakeModules/codesign.cmake)

add_subdirectory(third_party/catch2)


# testing and defines
enable_testing()

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")

find_package(Threads REQUIRED)

# Qt and Qwt
find_package(Qt5 OPTIONAL_COMPONENTS Core Gui Widgets OpenGL Network Help Concurrent Xml Svg Test LinguistTools)

find_package(Qwt)

if (UNIX AND NOT APPLE)
	find_package(Qt5X11Extras)
	find_package(Qt5DBus)
endif ()

# Zeroconf
include(CMakeModules/zeroconf.cmake)


# Aseba itself
set(LIB_INSTALL_DIR lib CACHE FILEPATH "Where to install libraries")
set(LIB_VERSION_MAJOR 3) # Must be bumped for incompatible ABI changes
set(LIB_VERSION_MINOR 0)
set(LIB_VERSION_PATCH 0)
set(LIB_VERSION_STRING ${LIB_VERSION_MAJOR}.${LIB_VERSION_MINOR}.${LIB_VERSION_PATCH})


add_subdirectory(aseba)

# Examples for developers
add_subdirectory(examples)

# Unit tests
add_subdirectory(tests)

# User entries
if (UNIX)
	add_subdirectory(menu)
endif()


if(EXISTS ${PROJECT_SOURCE_DIR}/thymio-blockly-standalone/CMakeLists.txt)
	add_subdirectory(${PROJECT_SOURCE_DIR}/thymio-blockly-standalone)
	message("-- Found thymio-blockly-standalone, will bundle blockly")
endif()


feature_summary( WHAT PACKAGES_FOUND PACKAGES_NOT_FOUND ENABLED_FEATURES DISABLED_FEATURES)


if(WIN32)
	add_subdirectory(third_party/bonjour)
	set(ASEBA_SOURCE_DIRECTORY "${PROJECT_SOURCE_DIR}")
	set(CPACK_MODULE_PATH ${PROJECT_SOURCE_DIR}/windows ${CPACK_MODULE_PATH})
	set(CPACK_MONOLITHIC_INSTALL 1)
	configure_file(
		${PROJECT_SOURCE_DIR}/windows/NSIS.definitions.nsh.in
		${CMAKE_CURRENT_BINARY_DIR}/resources/NSIS.definitions.nsh
	)

endif()

SET(CPACK_PACKAGE_VERSION_MAJOR "${ASEBA_VERSION_MAJOR}")
SET(CPACK_PACKAGE_VERSION_MINOR "${ASEBA_VERSION_MINOR}")
SET(CPACK_PACKAGE_VERSION_PATCH "${ASEBA_VERSION_PATCH}")
include(CPack)

=== aseba/CMakeLists.txt ===
# Core libraries
add_subdirectory(common)
add_subdirectory(transport)

# Target and client specific libraries
add_subdirectory(vm)
add_subdirectory(compiler)

# User programs
add_subdirectory(clients)
add_subdirectory(switches)
add_subdirectory(targets)

=== examples/CMakeLists.txt ===
# Different types of examples
add_subdirectory(clients)
add_subdirectory(switches)
if (HAS_ZEROCONF_SUPPORT)
	add_subdirectory(zeroconf)
endif()

=== menu/CMakeLists.txt ===
add_subdirectory(freedesktop)
add_subdirectory(src)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,15 +1,15 @@
-find_program(valgrind_FOUND valgrind)
-if (valgrind_FOUND)
-	message(STATUS "valgrind executable found: " ${valgrind_FOUND})
-else ()
-	message(WARNING "valgrind executable not found! Disabling memory leaks and trashs tests")
-endif ()
-
 add_subdirectory(common)
 add_subdirectory(msg)
-add_subdirectory(compiler)
-add_subdirectory(vm)
-add_subdirectory(simulator)
+
+include(CheckIncludeFiles)
+check_include_files(getopt.h HAVE_GETOPT_H)
+if (HAVE_GETOPT_H)
+	add_subdirectory(compiler)
+	add_subdirectory(vm)
+	add_subdirectory(simulator)
+endif()
+
+
 #add_subdirectory(e2e-http)
 
 
@@ -24,7 +24,7 @@
 #		# Support compilers like GCC 5 that don't have C++11 support enabled by default.
 #		target_compile_definitions(test-asebahttp PRIVATE -DCATCH_CONFIG_NO_CPP11)
 #	endif ()
-#	target_link_libraries(test-asebahttp asebahttphub asebacompiler ${LIBXML2_LIBRARIES} ${ASEBA_CORE_LIBRARIES})
+#	target_link_libraries(test-asebahttp asebahttphub asebacompiler ${LIBXML2_LIBRARIES} asebacommon)
 #	configure_file(testdata-HttpRequest.txt ${CMAKE_CURRENT_BINARY_DIR}/testdata-HttpRequest.txt COPYONLY)
 #	configure_file(http-valgrind-macosx.supp ${CMAKE_CURRENT_BINARY_DIR}/http-valgrind-macosx.supp COPYONLY)
 #	# test HTTP requests and JSON parsing

=== aseba/common/CMakeLists.txt ===
configure_file("version.cpp.tpl" "version.cpp")


add_library(asebacommon
	utils/FormatableString.cpp
	utils/utils.cpp
	utils/HexFile.cpp
	utils/BootloaderInterface.cpp
	msg/msg.cpp
	msg/NodesManager.cpp
	msg/TargetDescription.cpp
	${CMAKE_CURRENT_BINARY_DIR}/version.cpp
)
set_target_properties(asebacommon PROPERTIES VERSION ${LIB_VERSION_STRING})
target_link_libraries(asebacommon PUBLIC aseba_conf dashel)

target_link_libraries(aseba_conf)

install(TARGETS asebacommon 
	LIBRARY DESTINATION ${LIB_INSTALL_DIR} 
	ARCHIVE DESTINATION ${LIB_INSTALL_DIR} 
)

set (ASEBACORE_HDR_UTILS 
	utils/utils.h
	utils/FormatableString.h
)
set (ASEBACORE_HDR_MSG
	msg/msg.h
	msg/NodesManager.h
	msg/TargetDescription.h
)
set (ASEBACORE_HDR_COMMON
	consts.h
	types.h
	productids.h
)
install(FILES ${ASEBACORE_HDR_UTILS}
	DESTINATION include/aseba/common/utils
)
install(FILES ${ASEBACORE_HDR_MSG}
	DESTINATION include/aseba/common/msg
)
install(FILES ${ASEBACORE_HDR_COMMON}
	DESTINATION include/aseba/common
)

add_subdirectory(about)

if(HAS_ZEROCONF_SUPPORT)
	add_subdirectory(zeroconf)
endif()

=== aseba/compiler/CMakeLists.txt ===
set (ASEBACOMPILER_SRC
	compiler.cpp
	errors.cpp
	identifier-lookup.cpp
	lexer.cpp
	parser.cpp
	analysis.cpp
	tree-build.cpp
	tree-expand.cpp
	tree-dump.cpp
	tree-typecheck.cpp
	tree-optimize.cpp
	tree-emit.cpp
)
add_library(asebacompiler ${ASEBACOMPILER_SRC})
set_target_properties(asebacompiler PROPERTIES VERSION ${LIB_VERSION_STRING} 
                                        SOVERSION ${LIB_VERSION_MAJOR})

target_link_libraries(asebacompiler asebacommon)

codesign(asebacompiler)

install(TARGETS asebacompiler
                LIBRARY DESTINATION ${LIB_INSTALL_DIR} 
                ARCHIVE DESTINATION ${LIB_INSTALL_DIR} 
)

set (ASEBACORE_HDR_COMPILER
	compiler.h
	errors_code.h
)
install(FILES ${ASEBACORE_HDR_COMPILER}
	DESTINATION include/aseba/compiler
)

=== aseba/switches/CMakeLists.txt ===
add_subdirectory(switch)
add_subdirectory(medulla)
#FIXME: rename http2 and remove this one
add_subdirectory(http)
add_subdirectory(http2)

=== aseba/targets/CMakeLists.txt ===
add_subdirectory(dummy)
if (ENKI_FOUND)
	#add_subdirectory(enki-marxbot)
	add_subdirectory(challenge)
	add_subdirectory(playground)
endif()

=== aseba/transport/CMakeLists.txt ===
add_subdirectory(buffer)
add_subdirectory(dashel_plugins)

=== aseba/vm/CMakeLists.txt ===
if (APPLE)
	add_definitions(-DDISABLE_WEAK_CALLBACKS)
endif (APPLE)
set (ASEBAVM_SRC
	vm.c
	natives.c
)
add_library(asebavm STATIC ${ASEBAVM_SRC})
target_link_libraries(asebavm aseba_conf)
set_target_properties(asebavm PROPERTIES VERSION ${LIB_VERSION_STRING} 
                                        SOVERSION ${LIB_VERSION_MAJOR})

install(TARGETS asebavm 
                LIBRARY DESTINATION ${LIB_INSTALL_DIR} 
                ARCHIVE DESTINATION ${LIB_INSTALL_DIR} 
)

set (ASEBAVM_HDR_COMPILER
	vm.h
	natives.h
)
install(FILES ${ASEBAVM_HDR_COMPILER}
	DESTINATION include/aseba/vm
)

=== docs/en/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
SPHINXPROJ    = Aseba
SOURCEDIR     = .
BUILDDIR      = _build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== debian/changelog ===
aseba (1.6.99+dfsg-1) unstable; urgency=medium

  * New upstream version 1.6.99+dfsg
  * removed all useless debian patches
  * made a build-dependency on debhelper-compat (=12), removed debian/compat
  * upgraded Standards-Version: 4.5.0
  * made a versioned build-dependency on libenki-dev (>= 1.6.99)
  * replaced the build-dependency on python by another on python3.
    Closes: #970415; Closes: #936152

 -- Georges Khaznadar <georgesk@debian.org>  Thu, 17 Sep 2020 16:23:30 +0200

=== debian/control ===
--- 
+++ 
@@ -2,16 +2,17 @@
 Section: devel
 Priority: optional
 Maintainer: Georges Khaznadar <georgesk@debian.org>
-Build-Depends: debhelper (>= 10),
- cmake, python,
+Build-Depends: debhelper-compat (=12),
+ cmake, python3,
  qtbase5-dev, qt5-qmake, libqt5opengl5-dev, libqt5webkit5-dev,
- qtbase5-dev, qtbase5-dev-tools, qttools5-dev,
- libqt5svg5-dev, libqwt-qt5-dev, libqt5svg5-dev, qtchooser, qt5-default,
+ qtbase5-dev, qtbase5-dev-tools, qttools5-dev, libqt5x11extras5-dev,
+ libqt5svg5-dev, libqwt-qt5-dev, libqt5svg5-dev, qt5-qmake,
  libudev-dev, libxml2-dev, libsdl2-dev,
- libdashel-dev, libenki-dev,
+ libdashel-dev, libenki-dev (>= 1.6.99),
  libavahi-compat-libdnssd-dev,
- valgrind, libprotobuf-dev, zzuf
-Standards-Version: 4.1.3
+ valgrind [amd64 arm64 armhf i386 mips mips64el mipsel powerpc ppc64 ppc64el s390x],
+ libprotobuf-dev, zzuf
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/science-team/aseba.git
 Vcs-Git: https://salsa.debian.org/science-team/aseba.git
 Homepage: https://www.thymio.org/

=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,11 @@
 ifeq ($(shell hostname), georges)
   PARALLEL =
 else
-  PARALLEL = --no-parallel
+  ifeq ($(shell hostname), georges-pc)
+    PARALLEL =
+  else
+     PARALLEL = --no-parallel
+  endif
 endif
 
 export QT_SELECT=qt5

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%aseba-$1.tar.gz%" \
   https://github.com/aseba-community/aseba/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
